/*
Copyright 2023 ycyxuehan.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha1

import (
	corev1 "k8s.io/api/core/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// EDIT THIS FILE!  THIS IS SCAFFOLDING FOR YOU TO OWN!
// NOTE: json tags are required.  Any new fields you add must have json tags for the fields to be serialized.

// ZRunTemplateSpec defines the desired state of ZRunTemplate
type ZRunTemplateSpec struct {
	// INSERT ADDITIONAL SPEC FIELDS - desired state of cluster
	// Important: Run "make" to regenerate code after modifying this file

	// Foo is an example field of ZRunTemplate. Edit zruntemplate_types.go to remove/update
	// Foo string `json:"foo,omitempty"`
	// corev1.PodSpec `json:",inline"`
	InitContainers []corev1.Container   `json:"initContainers,omitempty"`
	Containers     []corev1.Container   `json:"containers,omitempty"`
	RestartPolicy  corev1.RestartPolicy `json:"restartPolicy,omitempty"`
	// Anffinity      *corev1.Affinity     `json:"anffinity,omitempty"`
	Dockerfile string `json:"dockerfile,omitempty"`
	Type       string `json:"type,omitempty"`
}

// ZRunTemplateStatus defines the observed state of ZRunTemplate
type ZRunTemplateStatus struct {
	// INSERT ADDITIONAL STATUS FIELD - define observed state of cluster
	// Important: Run "make" to regenerate code after modifying this file
}

//+kubebuilder:object:root=true
//+kubebuilder:subresource:status

// ZRunTemplate is the Schema for the zruntemplates API
type ZRunTemplate struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   ZRunTemplateSpec   `json:"spec,omitempty"`
	Status ZRunTemplateStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// ZRunTemplateList contains a list of ZRunTemplate
type ZRunTemplateList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []ZRunTemplate `json:"items"`
}

func init() {
	SchemeBuilder.Register(&ZRunTemplate{}, &ZRunTemplateList{})
}
