/*
Copyright 2023 ycyxuehan.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha1

import (
	corev1 "k8s.io/api/core/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// EDIT THIS FILE!  THIS IS SCAFFOLDING FOR YOU TO OWN!
// NOTE: json tags are required.  Any new fields you add must have json tags for the fields to be serialized.

// ZScriptSpec defines the desired state of ZScript
type ZScriptSpec struct {
	// INSERT ADDITIONAL SPEC FIELDS - desired state of cluster
	// Important: Run "make" to regenerate code after modifying this file

	// Foo is an example field of ZScript. Edit zscript_types.go to remove/update
	// Foo string `json:"foo,omitempty"`
	RunSpec    RunSpec                `json:"runSpec,omitempty"`    //run template for the script
	Path       string                 `json:"path,omitempty"`       //script path
	Project    corev1.ObjectReference `json:"project,omitempty"`    //存放脚本的项目
	Branch     string                 `json:"branch,omitempty"`     //code branch
	Env        []corev1.EnvVar        `json:"env,omitempty"`        //env
	CustomHost corev1.ObjectReference `json:"customHost,omitempty"` //host aliases, link to resource ZCustomHost
}

// ZScriptStatus defines the observed state of ZScript
type ZScriptStatus struct {
	// INSERT ADDITIONAL STATUS FIELD - define observed state of cluster
	// Important: Run "make" to regenerate code after modifying this file
}

//+kubebuilder:object:root=true
//+kubebuilder:subresource:status

// ZScript is the Schema for the zscripts API
type ZScript struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   ZScriptSpec   `json:"spec,omitempty"`
	Status ZScriptStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// ZScriptList contains a list of ZScript
type ZScriptList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []ZScript `json:"items"`
}

func init() {
	SchemeBuilder.Register(&ZScript{}, &ZScriptList{})
}
