package utils

import "encoding/json"

type MergeMode string

const (
	MergeOverrideByFirst  MergeMode = "MergeOverrideByFirst"  //覆盖模式，保留第一个
	MergeOverrideByLatest MergeMode = "MergeOverrideByLatest" //覆盖模式，保留最后一个
	MergeValue            MergeMode = "MergeValue"            //合并值
)

type DockerAuth struct {
	User       string `json:"username"`
	Password   string `json:"password"`
	AuthString string `json:"auth"`
}

func (da DockerAuth) String() string {
	data, err := json.Marshal(&da)
	if err != nil {
		return ""
	}
	return string(data)
}

type DockerConfig struct {
	AuthDataMap map[string]DockerAuth `json:"auths"`
}

func (dc DockerConfig) String() string {
	data, err := json.Marshal(&dc)
	if err != nil {
		return ""
	}
	return string(data)
}
