import { createRouter, createWebHistory, RouteRecordRaw } from "vue-router";
import Home from "../views/Home.vue";
//zelda resource
import ZGroup from "../views/zelda/ZGroup.vue";
import ZService from "../views/zelda/ZService.vue";
import ZProject from "../views/zelda/ZProject.vue";

//kubernetes resource
import Kubernetes from "../views/Kubernetes.vue";
//
import Login from "@/views/Login.vue";

const routes: Array<RouteRecordRaw> = [
  {
    path: "/",
    name: "Home",
    component: Home,
  },
  {
    path: "/resource",
    name: "Resource",
    component: Home,
    children: [
      { path: "/resource/zservice", name: "ZService", component: ZService },
      { path: "/resource/zgroup", name: "ZGroup", component: ZGroup },
      { path: "/resource/zproject", name: "ZProject", component: ZProject },
    ],
  },
  {
    path: "/kubernetes",
    name: "Kubernetes",
    component: Kubernetes,
    children: [
      { path: "/zservice", name: "Deployment", component: ZService },
      { path: "/zgroup", name: "Pod", component: ZGroup },
      { path: "/zproject", name: "Service", component: ZProject },
    ],
  },
  {
    path: "/about",
    name: "About",
    // route level code-splitting
    // this generates a separate chunk (about.[hash].js) for this route
    // which is lazy-loaded when the route is visited.
    component: () =>
      import(/* webpackChunkName: "about" */ "../views/About.vue"),
  },
  {
    path: "/login",
    name: "Login",
    component: Login,
  },
];

const router = createRouter({
  history: createWebHistory(process.env.BASE_URL),
  routes,
});

export default router;
